{% load static %}
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width,initial-scale=1">
        <link rel="stylesheet" href="{% static 'result.css'%}">
        <title>パスワード変更ページ</title>
        <style type="text/css">
            .hidden {
                display: none;
            }
        </style>
    </head>
    <body>
        <header>
            <div class="nav-bar">
                <p><span class="youthpod-logo">YouthPod</span></p>
            </div>
        </header>
        <main>
            <div id="message-box" class="message-box">
                <p id="changable-title">新しいパスワードを入力してください(8文字以上)</p>
                <form id="form" method="POST">
                <input type="hidden" name="uid" value="{{ uid }}">
                <input type="hidden" name="token" value="{{ token }}">
                <label for="new_password">新しいパスワード:</label><br>
                <input id="new_password" style="padding: 5px;" type="password" name="new_password" oninput="CheckPassword(this)" required><br>
                <label for="re_new_password">新しいパスワード(再入力):</label><br>
                <input id="re_new_password" style="padding: 5px;" type="password" name="re_new_password" oninput="CheckPassword(this)" required><br><br>
                <input style="padding: 5px 15px;" type="submit" value="変更"><br>
                </form>
                <p class="thank-you">Thank you. We all hope you enjoy <span class="youthpod-logo">YouthPod</span> :)</p>
            </div>
        </main>
        <footer>
            <p class="small">&copy; 2021 <span class="youthpod-logo">YouthPod</span> team.</p>
        </footer>

        <script>

            function CheckPassword(element){
                // 入力値取得
                let input1 = new_password.value;
                let input2 = re_new_password.value;

                if (input1 == "" || input2 == "") {
                    return;
                }
                // パスワード比較
                if (input1 != input2) {
                    element.setCustomValidity("入力値が一致しません。");
                } else {
                    element.setCustomValidity('');
                }
            }

            const form = document.getElementById("form");

            function toggleHidden (element) {
                if (element.classList.contains("hidden")) {
                    element.classList.remove("hidden");
                } else {
                    element.classList.add("hidden");
                }
            }

            window.addEventListener("load", function () {
                function sendData() {
                    // Awesome123TT
                    const XHR = new XMLHttpRequest();

                    // FormData オブジェクトと form 要素を紐づけます
                    const FD = new FormData(form);

                    // 表示が変化する部分
                    const mb = document.getElementById("message-box");

                    // データが正常に送信された場合に行うことを定義します
                    XHR.addEventListener("load", function(event) {
                        event.preventDefault();
                        let res_data = this.response;
                        if (!res_data) {
                            res_data = "{}";
                        };
                        const res = JSON.parse(res_data);
                        if (res_data == "{}") {
                            mb.innerHTML = "<p>パスワードが正しく変更されました！アプリに戻ってログインしてください。</p>\n<p class='thank-you'>Thank you. We all hope you enjoy <span class='youthpod-logo'>YouthPod</span> :)</p>";
                        } else if (res["errors"]) {
                            if (res["errors"]["token"]) {
                                mb.innerHTML = "<p>このリンクの有効期限が切れています。もう一度パスワード変更用メールを送信してください。</p>\n<p class='thank-you'>Thank you. We all hope you enjoy <span class='youthpod-logo'>YouthPod</span> :)</p>";
                            } else {
                                toggleHidden(form);
                                document.getElementById("changable-title").innerText = "8文字以上で、ある程度複雑なパスワードを入力してください。";
                            }
                        }
                    });

                    // エラーが発生した場合に行うことを定義します
                    XHR.addEventListener("error", function(event) {
                        toggleHidden(form);
                        alert('おっと、エラーが発生しました。インターネットの接続などを確認してもう一度実行してみてください。');
                    });

                    // リクエストをセットアップします
                    XHR.open("POST", "/auth/users/reset_password_confirm/");

                    // 送信したデータは、ユーザーがフォームで提供したものです
                    XHR.send(FD);
                    toggleHidden(form);
                    document.getElementById("changable-title").innerText = "パスワードを変更中です...";
                }

                // フォームの submit イベントを乗っ取ります
                form.addEventListener("submit", function (event) {
                    event.preventDefault();
                    sendData();
                });
            });
        </script>
    </body>
</html>
